<cfscript>
// Agms Response Component for Coldfusion
// Defines property and method to process a response from the Agms Gateway
// @author Maanas Royy
// @copyright Avant Garde Marketing Solutions Inc.

component
    output = "false"
    hint = "Agms Component"

    {

        /**
         * @hint responseParams
         */
        property 
            name = "responseParams"
            type = "struct"
        ;

        /**
         * @hint requestParams
         */
        property 
            name = "requestParams"
            type = "struct"
        ;

        public any function init()
        output = "false"
        {
            this.requestParams.TransactionType = "";
            this.requestParams.GatewayUserName = "";
            this.requestParams.GatewayPassword = "";
            this.requestParams.PaymentType = "";
            this.requestParams.Amount = "";
            this.requestParams.Tax = "";
            this.requestParams.Shipping = "";
            this.requestParams.OrderDescription = "";
            this.requestParams.OrderID = "";
            this.requestParams.PONumber = "";
            this.requestParams.CCNumber = "";
            this.requestParams.CCExpDate = "";
            this.requestParams.CVV = "";
            this.requestParams.CheckName = "";
            this.requestParams.CheckABA = "";
            this.requestParams.CheckAccount = "";
            this.requestParams.AccountHolderType = "";
            this.requestParams.AccountType = "";
            this.requestParams.SecCode = "";
            this.requestParams.FirstName = "";
            this.requestParams.LastName = "";
            this.requestParams.Company = "";
            this.requestParams.Address1 = "";
            this.requestParams.Address2 = "";
            this.requestParams.City = "";
            this.requestParams.State = "";
            this.requestParams.Zip = "";
            this.requestParams.Country = "";
            this.requestParams.Phone = "";
            this.requestParams.Fax = "";
            this.requestParams.EMail = "";
            this.requestParams.Website = "";
            this.requestParams.ShippingFirstName = "";
            this.requestParams.ShippingLastName = "";
            this.requestParams.ShippingCompany = "";
            this.requestParams.ShippingAddress1 = "";
            this.requestParams.ShippingAddress2 = "";
            this.requestParams.ShippingCity = "";
            this.requestParams.ShippingState = "";
            this.requestParams.ShippingZip = "";
            this.requestParams.ShippingCountry = "";
            this.requestParams.ShippingEmail = "";
            this.requestParams.ShippingPhone = "";
            this.requestParams.ShippingFax = "";
            this.requestParams.ProcessorID = "";
            this.requestParams.TransactionID = "";
            this.requestParams.Tracking_Number = "";
            this.requestParams.Shipping_Carrier = "";
            this.requestParams.IPAddress = "";
            this.requestParams.Track1 = "";
            this.requestParams.Track2 = "";
            this.requestParams.Track3 = "";
            this.requestParams.Track_Type = "";
            this.requestParams.Custom_Field_1 = "";
            this.requestParams.Custom_Field_2 = "";
            this.requestParams.Custom_Field_3 = "";
            this.requestParams.Custom_Field_4 = "";
            this.requestParams.Custom_Field_5 = "";
            this.requestParams.Custom_Field_6 = "";
            this.requestParams.Custom_Field_7 = "";
            this.requestParams.Custom_Field_8 = "";
            this.requestParams.Custom_Field_9 = "";
            this.requestParams.Custom_Field_10 = "";
            this.requestParams.SAFE_Action = "";
            this.requestParams.SAFE_ID = "";
            this.requestParams.ReceiptType = "";
            this.requestParams.MICR = "";
            this.requestParams.MICRSymbolSet = "";
            this.requestParams.CheckFrontTIFF = "";
            this.requestParams.CheckBackTIFF = "";
            this.requestParams.CheckNumber = "";
            this.requestParams.Terminal_ID = "";
            this.requestParams.CCNumber2 = "";
            this.requestParams.Clerk_ID = "";
            this.requestParams.Billing_Code = "";
            this.requestParams.InvoiceID = "";
            this.requestParams.BatchID = "";
            this.requestParams.DLNumber = "";
            this.requestParams.DLState = "";
            this.requestParams.IdentityVerification = "";
            this.requestParams.CourtesyCardID = "";
            this.requestParams.MagData = "";

            this.responseParams.STATUS_CODE = "";
            this.responseParams.STATUS_MSG = "";
            this.responseParams.TRANS_ID = "";
            this.responseParams.AUTH_CODE = "";
            this.responseParams.AVS_CODE = "";
            this.responseParams.AVS_MSG = "";
            this.responseParams.CVV2_CODE = "";
            this.responseParams.CVV2_MSG = "";
            this.responseParams.ORDERID = "";
            this.responseParams.SAFE_ID = "";
            this.responseParams.FULLRESPONSE = "";
            this.responseParams.POSTSTRING = "";
            this.responseParams.BALANCE = "";
            this.responseParams.GIFTRESPONSE = "";
            this.responseParams.MERCHANT_ID = "";
            this.responseParams.CUSTOMER_MESSAGE = "";
        }
        

        public any function ProcessTransaction (required struct params)
        output = "false"

        {
            /*
             * Assign the params to requestParams
             */
            for (key in params){
                this.requestParams[key] = params[key];
            }

            /*
             * Create a webservice object
             */
            ws = CreateObject("webservice", "https://gateway.agms.com/roxapi/agms.asmx?WSDL");
            
            /*
             * Call the Soap Method
             */
            ws.ProcessTransaction(this.requestParams);
            
            /*
             * Retrieve Soap Response, the response is a structure again
             */
            respXml = getSOAPResponse(ws);
            
            /*
             * Parse xml response in responseParams Struct
             */
            this.responseParams.STATUS_CODE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['STATUS_CODE']['XmlText'];

            this.responseParams.STATUS_MSG = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['STATUS_MSG']['XmlText'];
            
            this.responseParams.TRANS_ID = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['TRANS_ID']['XmlText'];
            
            this.responseParams.AUTH_CODE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['AUTH_CODE']['XmlText'];
            
            this.responseParams.AVS_CODE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['AVS_CODE']['XmlText'];
            
            this.responseParams.AVS_MSG = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['AVS_MSG']['XmlText'];
            
            this.responseParams.CVV2_CODE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['CVV2_CODE']['XmlText'];
            
            this.responseParams.CVV2_MSG = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['CVV2_MSG']['XmlText'];
            
            this.responseParams.ORDERID = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['ORDERID']['XmlText'];
            
            this.responseParams.SAFE_ID = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['SAFE_ID']['XmlText'];
            
            this.responseParams.FULLRESPONSE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['FULLRESPONSE']['XmlText'];
            
            this.responseParams.POSTSTRING = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['POSTSTRING']['XmlText'];
            
            this.responseParams.BALANCE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['BALANCE']['XmlText'];
            
            this.responseParams.GIFTRESPONSE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['GIFTRESPONSE']['XmlText'];
            
            this.responseParams.MERCHANT_ID = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['MERCHANT_ID']['XmlText'];
            
            this.responseParams.CUSTOMER_MESSAGE = respXml['soap:Envelope']['soap:Body']['ProcessTransactionResponse']['ProcessTransactionResult']['CUSTOMER_MESSAGE']['XmlText'];
            
            return this.responseParams;
        }
    }
</cfscript>